/*
 *  Point.h
 */

#ifndef Point_h
#define Point_h 1

#include "BasicTypes.h"

class tPoint
{
public:
	SInt32 x; 
	SInt32 y; 
	
	tPoint() : x(0), y(0) {}	
	tPoint(const SInt32 x2, const SInt32 y2) : x(x2), y(y2) {}
	
	~tPoint() {}
	
	void mSet(const SInt32 x2, const SInt32 y2)
	{
		x = x2; 
		y = y2; 
	}
	
	bool operator==(const tPoint& p) const 
	{
		return x == p.x && y == p.y; 
	}
	
	bool operator!=(const tPoint& p) const 
	{
		return x != p.x || y != p.y; 
	}
	
	tPoint& operator=(const tPoint& p)
	{
		x = p.x; 
		y = p.y; 
		return *this; 
	}
	
	inline tPoint	operator+(const tPoint& p);
	inline tPoint&	operator+=(const tPoint& p);
};

const tPoint kZeroPoint(0, 0);

inline tPoint tPoint::operator+(const tPoint& p)
{
	tPoint point; 
	point.x = x + p.x; 
	point.y = y + p.y; 
	
	return point; 
}

inline tPoint& tPoint::operator+=(const tPoint& p)
{
	x += p.x; 
	y += p.y; 
	return *this; 
}

#endif
